Index: trunk/source/Lib/TLibEncoder/TEncSearch.cpp
===================================================================
--- trunk/source/Lib/TLibEncoder/TEncSearch.cpp	(revision 81)
+++ trunk/source/Lib/TLibEncoder/TEncSearch.cpp	(revision 100)
@@ -304,5 +304,5 @@
   // motion cost
   uiSad += m_pcRdCost->getCost( iSearchX, iSearchY );
-#if HHI_FIX  
+
   // regularization cost
   if( m_pcRdCost->useMultiviewReg() )
@@ -310,5 +310,4 @@
     uiSad += m_pcRdCost->getMultiviewRegCost( iSearchX, iSearchY );
   }
-#endif
   if( uiSad < rcStruct.uiBestSad )
   {
@@ -957,5 +956,9 @@
                                 TComYuv*    pcPredYuv, 
                                 TComYuv*    pcResiYuv, 
-                                Dist&       ruiDist )
+                                Dist&       ruiDist 
+#if LG_ZEROINTRADEPTHRESI_M26039
+                                ,Bool        bZeroResi
+#endif
+                                )
 {
   UInt    uiLumaPredMode    = pcCU     ->getLumaIntraDir     ( uiAbsPartIdx );
@@ -989,4 +992,21 @@
   pcCU->getPattern()->initAdiPattern( pcCU, uiAbsPartIdx, uiTrDepth, m_piYuvExt, m_iYuvExtStride, m_iYuvExtHeight, bAboveAvail, bLeftAvail );
   
+#if LGE_EDGE_INTRA
+  if( uiLumaPredMode >= EDGE_INTRA_IDX )
+  {
+#if LGE_EDGE_INTRA_DELTA_DC
+    if( uiLumaPredMode == EDGE_INTRA_DELTA_IDX )
+      xAssignEdgeIntraDeltaDCs( pcCU, uiAbsPartIdx, piOrg, uiStride, piPred, uiWidth, uiHeight );
+#endif
+
+    predIntraLumaEdge( pcCU, pcCU->getPattern(), uiAbsPartIdx, uiWidth, uiHeight, piPred, uiStride
+#if LGE_EDGE_INTRA_DELTA_DC
+     , uiLumaPredMode == EDGE_INTRA_DELTA_IDX
+#endif
+    );
+  }
+  else
+#endif
+  
   //===== get prediction signal =====
 #if HHI_DMM_WEDGE_INTRA || HHI_DMM_PRED_TEX
@@ -1020,4 +1040,16 @@
     }
   }
+#if LG_ZEROINTRADEPTHRESI_M26039
+  if(bZeroResi)
+  {
+    Pel* pResi = piResi;
+
+    for( UInt uiY = 0; uiY < uiHeight; uiY++ )
+    {
+      memset( pResi, 0, sizeof( Pel ) * uiWidth );
+      pResi += uiStride;
+    }
+  }
+#endif
   
   //===== transform and quantization =====
@@ -1311,5 +1343,9 @@
                                 Bool         bCheckFirst,
 #endif
-                                Double&      dRDCost )
+                                Double&      dRDCost 
+#if LG_ZEROINTRADEPTHRESI_M26039
+                               ,Bool         bZeroResi
+#endif
+                              )
 {
   UInt    uiFullDepth   = pcCU->getDepth( 0 ) +  uiTrDepth;
@@ -1326,4 +1362,10 @@
 #if HHI_DMM_WEDGE_INTRA || HHI_DMM_PRED_TEX
   if( pcCU->getLumaIntraDir( uiAbsPartIdx ) >= NUM_INTRA_MODE )
+  {
+    bCheckSplit = false;
+  }
+#endif
+#if LGE_EDGE_INTRA
+  if( pcCU->getLumaIntraDir( uiAbsPartIdx ) >= EDGE_INTRA_IDX )
   {
     bCheckSplit = false;
@@ -1346,5 +1388,9 @@
     //----- code luma block with given intra prediction mode and store Cbf-----
     dSingleCost   = 0.0;
+#if LG_ZEROINTRADEPTHRESI_M26039
+    xIntraCodingLumaBlk( pcCU, uiTrDepth, uiAbsPartIdx, pcOrgYuv, pcPredYuv, pcResiYuv, uiSingleDistY, bZeroResi ); 
+#else
     xIntraCodingLumaBlk( pcCU, uiTrDepth, uiAbsPartIdx, pcOrgYuv, pcPredYuv, pcResiYuv, uiSingleDistY ); 
+#endif
     if( bCheckSplit )
     {
@@ -1808,4 +1854,19 @@
     Int numModesForFullRD = g_aucIntraModeNumFast[ uiWidthBit ];
     
+#if LGE_EDGE_INTRA
+  Bool bTestEdgeIntra = false;
+  if ( m_pcEncCfg->isDepthCoder() && uiWidth >= LGE_EDGE_INTRA_MIN_SIZE && uiWidth <= LGE_EDGE_INTRA_MAX_SIZE && uiWidth == uiHeight )
+  {
+    bTestEdgeIntra = true;
+
+    Bool bEdgeExist;
+
+    bEdgeExist = xEdgePartition( pcCU, uiPartOffset, pcCU->getPartitionSize(0) == SIZE_NxN );
+
+    if( !bEdgeExist )
+      bTestEdgeIntra = false;
+  }
+#endif
+    
 #if HHI_DMM_WEDGE_INTRA || HHI_DMM_PRED_TEX
     Bool bTestDmm = ( m_pcEncCfg->getUseDMM() );
@@ -1828,42 +1889,58 @@
 
         predIntraLumaAng( pcCU->getPattern(), uiMode, piPred, uiStride, uiWidth, uiHeight, pcCU, bAboveAvail, bLeftAvail );
-        
+
         // use hadamard transform here
-      Dist uiSad;
+        Dist uiSad;
 #if HHI_VSO
-      if ( m_pcRdCost->getUseVSO() )
-      {
-        Bool bSad = !m_pcRdCost->getUseRenModel();
-        uiSad = m_pcRdCost->getDistVS(pcCU, uiPartOffset, piPred, uiStride, piOrg, uiStride, uiWidth, uiHeight, bSad, 0 );
-      }
-      else
-#endif
-      {
-        uiSad = (Dist) m_pcRdCost->calcHAD( piOrg, uiStride, piPred, uiStride, uiWidth, uiHeight );
-      }
-        
+        if ( m_pcRdCost->getUseVSO() )
+        {
+#if SAIT_VSO_EST_A0033
+          if ( m_pcRdCost->getUseEstimatedVSD() )
+          {          
+            TComPicYuv* pcVirRec = m_pcRdCost->getVideoRecPicYuv();
+            TComPicYuv* pcVirOrg = m_pcRdCost->getDepthPicYuv();
+
+            uiSad = (Dist) ( m_pcRdCost->getDistPart( piPred, uiStride, piOrg, uiStride, pcVirRec->getLumaAddr(pcCU->getAddr(),pcCU->getZorderIdxInCU()+uiPartOffset), pcVirOrg->getLumaAddr(pcCU->getAddr(),pcCU->getZorderIdxInCU()+uiPartOffset), pcVirRec->getStride(), uiWidth, uiHeight ) );
+          }
+          else
+#endif
+          {          
+            Bool bSad = !m_pcRdCost->getUseRenModel();
+            uiSad = m_pcRdCost->getDistVS(pcCU, uiPartOffset, piPred, uiStride, piOrg, uiStride, uiWidth, uiHeight, bSad, 0 );
+          }
+
+        }
+        else
+#endif
+        {
+          uiSad = (Dist) m_pcRdCost->calcHAD( piOrg, uiStride, piPred, uiStride, uiWidth, uiHeight );
+        }
+
         UInt   iModeBits = xModeBitsIntra( pcCU, uiMode, uiPU, uiPartOffset, uiDepth, uiInitTrDepth );
 
-      Double dLambda;
+        Double dLambda;
 #if HHI_VSO
-      if ( m_pcRdCost->getUseLambdaScaleVSO() )
-      {
-        dLambda = m_pcRdCost->getUseRenModel() ? m_pcRdCost->getLambdaVSO() : m_pcRdCost->getSqrtLambdaVSO();
-        //GT: Sad is SSE for VSO4
-      }
-      else
-      {
+        if ( m_pcRdCost->getUseLambdaScaleVSO() )
+        {
+          dLambda = m_pcRdCost->getUseRenModel() ? m_pcRdCost->getLambdaVSO() : m_pcRdCost->getSqrtLambdaVSO();
+          //GT: Sad is SSE for VSO4
+        }
+        else
+        {
+          dLambda = m_pcRdCost->getSqrtLambda();
+        }
+#else
         dLambda = m_pcRdCost->getSqrtLambda();
-      }
-#else
-      dLambda = m_pcRdCost->getSqrtLambda();
-#endif
-
-      Double cost = (Double)uiSad + (Double)iModeBits *  dLambda;
-        
+#endif
+
+        Double cost = (Double)uiSad + (Double)iModeBits *  dLambda;
+
         CandNum += xUpdateCandList( uiMode, cost, numModesForFullRD, uiRdModeList, CandCostList );
 
 #if HHI_DMM_WEDGE_INTRA || HHI_DMM_PRED_TEX
         if( bTestDmm ) bTestDmm = uiSad ? true : false;
+#endif
+#if LGE_EDGE_INTRA
+        if ( bTestEdgeIntra ) bTestEdgeIntra = uiSad ? true : false;
 #endif
       }
@@ -1974,4 +2051,13 @@
     }
 #endif
+#if LGE_EDGE_INTRA
+  if( bTestEdgeIntra )
+  {
+    uiRdModeList[ numModesForFullRD++ ] = EDGE_INTRA_IDX;
+#if LGE_EDGE_INTRA_DELTA_DC
+    uiRdModeList[ numModesForFullRD++ ] = EDGE_INTRA_DELTA_IDX;
+#endif
+  }
+#endif
 
     //===== check modes (using r-d costs) =====
@@ -1987,9 +2073,19 @@
     for( UInt uiMode = 0; uiMode < numModesForFullRD; uiMode++ )
     {
+#if LG_ZEROINTRADEPTHRESI_M26039
+    Bool bAllowZeroResi = pcCU->getSlice()->getIsDepth() && (pcCU->getSlice()->getPOC()%pcCU->getPic()->getIntraPeriod());// && (uiMode < NUM_INTRA_MODE);
+    for(UInt uiCnt = 0; uiCnt < (bAllowZeroResi ? 2 : 1); uiCnt++)
+    {
+      Bool bZeroResi = uiCnt ? true : false;
+#endif
       // set luma prediction mode
       UInt uiOrgMode = uiRdModeList[uiMode];
-      
+
 #if HHI_DMM_WEDGE_INTRA || HHI_DMM_PRED_TEX
-      if( m_pcEncCfg->getIsDepth() && !predIntraLumaDMMAvailable( uiOrgMode, uiWidth, uiHeight ) )
+      if( m_pcEncCfg->getIsDepth() && !predIntraLumaDMMAvailable( uiOrgMode, uiWidth, uiHeight ) 
+#if LGE_EDGE_INTRA
+        && uiOrgMode < EDGE_INTRA_IDX
+#endif
+        )
       {
         continue;
@@ -2020,5 +2116,9 @@
 
 #if HHI_RQT_INTRA_SPEEDUP
+#if LG_ZEROINTRADEPTHRESI_M26039
+      xRecurIntraCodingQT( pcCU, uiInitTrDepth, uiPartOffset, bLumaOnly, pcOrgYuv, pcPredYuv, pcResiYuv, uiPUDistY, uiPUDistC, true, dPUCost, bZeroResi );
+#else
       xRecurIntraCodingQT( pcCU, uiInitTrDepth, uiPartOffset, bLumaOnly, pcOrgYuv, pcPredYuv, pcResiYuv, uiPUDistY, uiPUDistC, true, dPUCost );
+#endif
 #else
       xRecurIntraCodingQT( pcCU, uiInitTrDepth, uiPartOffset, bLumaOnly, pcOrgYuv, pcPredYuv, pcResiYuv, uiPUDistY, uiPUDistC, dPUCost );
@@ -2052,4 +2152,7 @@
         dSecondBestPUCost = dPUCost;
       }
+#endif
+#if LG_ZEROINTRADEPTHRESI_M26039
+    }
 #endif
     } // Mode loop
@@ -2579,31 +2682,31 @@
       pcCU->getCUMvField(REF_PIC_LIST_1)->setAllMvField( cMvFieldNeighbours[1 + 2*uiMergeCand], ePartSize, uiAbsPartIdx, 0, iPUIdx );
 #if LG_RESTRICTEDRESPRED_M24766
-	  Int iAddResiShift;
-	  UInt uiPartAddr;
-	  Int iRoiWidth, iRoiHeight;
-
-	  pcCU->getPartIndexAndSize( iPUIdx, uiPartAddr, iRoiWidth, iRoiHeight );
-	  iAddResiShift = pcCU->getResiPredMode(uiPartAddr);
-	  iAddResiShift = (pcCU->getSlice()->getPPS()->getUseWP() || pcCU->getInterDir(uiPartAddr) != 3) ? (iAddResiShift >= 0 ? 0 : -1) : (iAddResiShift >= 0 ? 1 - iAddResiShift : -1);
-
-	  if( pcCU->getResPredFlag( 0 ))
-	  { // subtract residual prediction from original in motion search
-		  if(iLastAddResiShift != iAddResiShift)
-		  {
-			  //add subtracted residual last time
-			  if(iLastAddResiShift >= 0)
-			  {
-				  iPUResiPredShift[0] = iPUResiPredShift[1] = iPUResiPredShift[2] = iPUResiPredShift[3] = iLastAddResiShift;
-				  pcYuvOrg->add(iPUResiPredShift, ePartSize, rpcResiPredYuv, pcCU->getWidth( 0 ), pcCU->getHeight( 0 ));
-			  }
-			  //subtract residual
-			  if(iAddResiShift >= 0)
-			  {
-				  iPUResiPredShift[0] = iPUResiPredShift[1] = iPUResiPredShift[2] = iPUResiPredShift[3] = iAddResiShift;
-				  pcYuvOrg->add(iPUResiPredShift, ePartSize, rpcResiPredYuv, pcCU->getWidth( 0 ), pcCU->getHeight( 0 ), true );
-			  }
-			  iLastAddResiShift = iAddResiShift;
-		  }
-	  }
+      Int iAddResiShift;
+      UInt uiPartAddr;
+      Int iRoiWidth, iRoiHeight;
+
+      pcCU->getPartIndexAndSize( iPUIdx, uiPartAddr, iRoiWidth, iRoiHeight );
+      iAddResiShift = pcCU->getResiPredMode(uiPartAddr);
+      iAddResiShift = (pcCU->getSlice()->getPPS()->getUseWP() || pcCU->getInterDir(uiPartAddr) != 3) ? (iAddResiShift >= 0 ? 0 : -1) : (iAddResiShift >= 0 ? 1 - iAddResiShift : -1);
+
+      if( pcCU->getResPredFlag( 0 ))
+      { // subtract residual prediction from original in motion search
+        if(iLastAddResiShift != iAddResiShift)
+        {
+          //add subtracted residual last time
+          if(iLastAddResiShift >= 0)
+          {
+            iPUResiPredShift[0] = iPUResiPredShift[1] = iPUResiPredShift[2] = iPUResiPredShift[3] = iLastAddResiShift;
+            pcYuvOrg->add(iPUResiPredShift, ePartSize, rpcResiPredYuv, pcCU->getWidth( 0 ), pcCU->getHeight( 0 ));
+          }
+          //subtract residual
+          if(iAddResiShift >= 0)
+          {
+            iPUResiPredShift[0] = iPUResiPredShift[1] = iPUResiPredShift[2] = iPUResiPredShift[3] = iAddResiShift;
+            pcYuvOrg->add(iPUResiPredShift, ePartSize, rpcResiPredYuv, pcCU->getWidth( 0 ), pcCU->getHeight( 0 ), true );
+          }
+          iLastAddResiShift = iAddResiShift;
+        }
+      }
 #endif
       xGetInterPredictionError( pcCU, pcYuvOrg, iPUIdx, uiCostCand, m_pcEncCfg->getUseHADME() );
@@ -2631,6 +2734,6 @@
   if( pcCU->getResPredFlag( 0 ) && iLastAddResiShift >= 0)
   {
-	  iPUResiPredShift[0] = iPUResiPredShift[1] = iPUResiPredShift[2] = iPUResiPredShift[3] = iLastAddResiShift;
-	  pcYuvOrg->add(iPUResiPredShift, pcCU->getPartitionSize(0), rpcResiPredYuv, pcCU->getWidth( 0 ), pcCU->getHeight( 0 ));
+    iPUResiPredShift[0] = iPUResiPredShift[1] = iPUResiPredShift[2] = iPUResiPredShift[3] = iLastAddResiShift;
+    pcYuvOrg->add(iPUResiPredShift, pcCU->getPartitionSize(0), rpcResiPredYuv, pcCU->getWidth( 0 ), pcCU->getHeight( 0 ));
   }
 #endif
@@ -2755,5 +2858,5 @@
     UInt          uiBitsTempL0[MAX_NUM_REF];
 #if LG_RESTRICTEDRESPRED_M24766
-	Int iPUResiPredShift[4] = {0, 0, 0, 0};
+    Int iPUResiPredShift[4] = {0, 0, 0, 0};
 #endif
     xGetBlkBits( ePartSize, pcCU->getSlice()->isInterP(), iPartIdx, uiLastMode, uiMbBits);
@@ -2773,5 +2876,5 @@
 #endif
 #if LG_RESTRICTEDRESPRED_M24766
-		Bool bLastResiFlag = false;
+      Bool bLastResiFlag = false;
 #endif
     //  Uni-directional prediction
@@ -2783,19 +2886,19 @@
       {
 #if LG_RESTRICTEDRESPRED_M24766
-		  if( pcCU->getResPredFlag( 0 ))
-		  {
-			  if(pcCU->getSlice()->getViewId() == pcCU->getSlice()->getRefViewId(eRefPicList, iRefIdxTemp))
-			  { // subtract residual prediction from original in motion search
-				  if(!bLastResiFlag)
-					  pcOrgYuv->add(iPUResiPredShift, pcCU->getPartitionSize(0), rpcResiPredYuv, pcCU->getWidth( 0 ), pcCU->getHeight( 0 ), true );
-				  bLastResiFlag = true;
-			  }
-			  else
-			  {
-				  if(bLastResiFlag)
-					  pcOrgYuv->add(iPUResiPredShift, pcCU->getPartitionSize(0), rpcResiPredYuv, pcCU->getWidth( 0 ), pcCU->getHeight( 0 ));
-				  bLastResiFlag = false;
-			  }
-		  }
+        if( pcCU->getResPredFlag( 0 ))
+        {
+          if(pcCU->getSlice()->getViewId() == pcCU->getSlice()->getRefViewId(eRefPicList, iRefIdxTemp))
+          { // subtract residual prediction from original in motion search
+            if(!bLastResiFlag)
+              pcOrgYuv->add(iPUResiPredShift, pcCU->getPartitionSize(0), rpcResiPredYuv, pcCU->getWidth( 0 ), pcCU->getHeight( 0 ), true );
+            bLastResiFlag = true;
+          }
+          else
+          {
+            if(bLastResiFlag)
+              pcOrgYuv->add(iPUResiPredShift, pcCU->getPartitionSize(0), rpcResiPredYuv, pcCU->getWidth( 0 ), pcCU->getHeight( 0 ));
+            bLastResiFlag = false;
+          }
+        }
 #endif
         uiBitsTemp = uiMbBits[iRefList];
@@ -2963,8 +3066,8 @@
     }
 #if LG_RESTRICTEDRESPRED_M24766
-	if( pcCU->getResPredFlag( 0 ) && bLastResiFlag)
-	{ // subtract residual prediction from original in motion search
-		pcOrgYuv->add(iPUResiPredShift, pcCU->getPartitionSize(0), rpcResiPredYuv, pcCU->getWidth( 0 ), pcCU->getHeight( 0 ));
-	}
+    if( pcCU->getResPredFlag( 0 ) && bLastResiFlag)
+    { // subtract residual prediction from original in motion search
+      pcOrgYuv->add(iPUResiPredShift, pcCU->getPartitionSize(0), rpcResiPredYuv, pcCU->getWidth( 0 ), pcCU->getHeight( 0 ));
+    }
 #endif
     //  Bi-directional prediction
@@ -2972,5 +3075,5 @@
     {
 #if LG_RESTRICTEDRESPRED_M24766
-		Int iLastAddResiShift = -1000;
+      Int iLastAddResiShift = -1000;
 #endif
       cMvBi[0] = cMv[0];            cMvBi[1] = cMv[1];
@@ -3077,33 +3180,33 @@
 #endif
 #if LG_RESTRICTEDRESPRED_M24766
-		  Int iAddResiShift = -1, iPredFrom = 0;
-		  Int iBestRefIdx = pcCU->getCUMvField(eRefPicList == REF_PIC_LIST_0 ? REF_PIC_LIST_1 : REF_PIC_LIST_0)->getRefIdx(uiPartAddr);
-
-		  iPredFrom = iBestRefIdx >= 0 ? 3 : 1;
-		  if(iBestRefIdx >= 0 && pcCU->getSlice()->getViewId() == pcCU->getSlice()->getRefViewId(eRefPicList == REF_PIC_LIST_0 ? REF_PIC_LIST_1 : REF_PIC_LIST_0, iBestRefIdx))
-			  iAddResiShift++;
-		  if(pcCU->getSlice()->getViewId() == pcCU->getSlice()->getRefViewId(eRefPicList, iRefIdxTemp))
-			  iAddResiShift++;
-		  iAddResiShift = (pcCU->getSlice()->getPPS()->getUseWP() || iPredFrom != 3) ? (iAddResiShift >= 0 ? 0 : -1) : (iAddResiShift >= 0 ? 1-iAddResiShift : -1);
-
-		  if( pcCU->getResPredFlag( 0 ) )
-		  {
-			  if(iLastAddResiShift != iAddResiShift)
-			  {
-				  //add substracted residual last time
-				  if(iLastAddResiShift >= 0 )
-				  {
-					  iPUResiPredShift[0] = iPUResiPredShift[1] = iPUResiPredShift[2] = iPUResiPredShift[3] = iLastAddResiShift;
-					  pcOrgYuv->add(iPUResiPredShift, pcCU->getPartitionSize(0), rpcResiPredYuv, pcCU->getWidth( 0 ), pcCU->getHeight( 0 ));
-				  }
-				  //substract residual
-				  if(iAddResiShift >= 0)
-				  {
-					  iPUResiPredShift[0] = iPUResiPredShift[1] = iPUResiPredShift[2] = iPUResiPredShift[3] = iAddResiShift;
-					  pcOrgYuv->add(iPUResiPredShift, pcCU->getPartitionSize(0), rpcResiPredYuv, pcCU->getWidth( 0 ), pcCU->getHeight( 0 ), true );
-				  }
-				  iLastAddResiShift = iAddResiShift;
-			  }
-		  }
+          Int iAddResiShift = -1, iPredFrom = 0;
+          Int iBestRefIdx = pcCU->getCUMvField(eRefPicList == REF_PIC_LIST_0 ? REF_PIC_LIST_1 : REF_PIC_LIST_0)->getRefIdx(uiPartAddr);
+
+          iPredFrom = iBestRefIdx >= 0 ? 3 : 1;
+          if(iBestRefIdx >= 0 && pcCU->getSlice()->getViewId() == pcCU->getSlice()->getRefViewId(eRefPicList == REF_PIC_LIST_0 ? REF_PIC_LIST_1 : REF_PIC_LIST_0, iBestRefIdx))
+            iAddResiShift++;
+          if(pcCU->getSlice()->getViewId() == pcCU->getSlice()->getRefViewId(eRefPicList, iRefIdxTemp))
+            iAddResiShift++;
+          iAddResiShift = (pcCU->getSlice()->getPPS()->getUseWP() || iPredFrom != 3) ? (iAddResiShift >= 0 ? 0 : -1) : (iAddResiShift >= 0 ? 1-iAddResiShift : -1);
+
+          if( pcCU->getResPredFlag( 0 ) )
+          {
+            if(iLastAddResiShift != iAddResiShift)
+            {
+              //add substracted residual last time
+              if(iLastAddResiShift >= 0 )
+              {
+                iPUResiPredShift[0] = iPUResiPredShift[1] = iPUResiPredShift[2] = iPUResiPredShift[3] = iLastAddResiShift;
+                pcOrgYuv->add(iPUResiPredShift, pcCU->getPartitionSize(0), rpcResiPredYuv, pcCU->getWidth( 0 ), pcCU->getHeight( 0 ));
+              }
+              //substract residual
+              if(iAddResiShift >= 0)
+              {
+                iPUResiPredShift[0] = iPUResiPredShift[1] = iPUResiPredShift[2] = iPUResiPredShift[3] = iAddResiShift;
+                pcOrgYuv->add(iPUResiPredShift, pcCU->getPartitionSize(0), rpcResiPredYuv, pcCU->getWidth( 0 ), pcCU->getHeight( 0 ), true );
+              }
+              iLastAddResiShift = iAddResiShift;
+            }
+          }
 #endif
           // call ME
@@ -3162,9 +3265,9 @@
       } // for loop-iter
 #if LG_RESTRICTEDRESPRED_M24766
-	  if( pcCU->getResPredFlag( 0 ) && iLastAddResiShift >= 0)
-	  {
-		  iPUResiPredShift[0] = iPUResiPredShift[1] = iPUResiPredShift[2] = iPUResiPredShift[3] = iLastAddResiShift;
-		  pcOrgYuv->add(iPUResiPredShift, pcCU->getPartitionSize(0), rpcResiPredYuv, pcCU->getWidth( 0 ), pcCU->getHeight( 0 ));
-	  }
+      if( pcCU->getResPredFlag( 0 ) && iLastAddResiShift >= 0)
+      {
+        iPUResiPredShift[0] = iPUResiPredShift[1] = iPUResiPredShift[2] = iPUResiPredShift[3] = iLastAddResiShift;
+        pcOrgYuv->add(iPUResiPredShift, pcCU->getPartitionSize(0), rpcResiPredYuv, pcCU->getWidth( 0 ), pcCU->getHeight( 0 ));
+      }
 #endif
     } // if (B_SLICE)
@@ -3375,19 +3478,19 @@
       {
 #if LG_RESTRICTEDRESPRED_M24766
-		  Int iAddResiShift = pcCU->getResiPredMode(uiPartAddr);
-		  iPUResiPredShift[0] = iPUResiPredShift[1] = iPUResiPredShift[2] = iPUResiPredShift[3] = \
-			  (pcCU->getSlice()->getPPS()->getUseWP() || pcCU->getInterDir(uiPartAddr) != 3)? (iAddResiShift >= 0 ? 0 : -1) : (iAddResiShift >= 0 ? 1-iAddResiShift : -1);
-		  if(pcCU->getResPredFlag(0) && iAddResiShift >= 0)
-		  {
-			  pcOrgYuv->add(iPUResiPredShift, pcCU->getPartitionSize(0), rpcResiPredYuv, pcCU->getWidth( 0 ), pcCU->getHeight( 0 ), true);
-		  }
+        Int iAddResiShift = pcCU->getResiPredMode(uiPartAddr);
+        iPUResiPredShift[0] = iPUResiPredShift[1] = iPUResiPredShift[2] = iPUResiPredShift[3] = \
+          (pcCU->getSlice()->getPPS()->getUseWP() || pcCU->getInterDir(uiPartAddr) != 3)? (iAddResiShift >= 0 ? 0 : -1) : (iAddResiShift >= 0 ? 1-iAddResiShift : -1);
+        if(pcCU->getResPredFlag(0) && iAddResiShift >= 0)
+        {
+          pcOrgYuv->add(iPUResiPredShift, pcCU->getPartitionSize(0), rpcResiPredYuv, pcCU->getWidth( 0 ), pcCU->getHeight( 0 ), true);
+        }
 #endif
         xGetInterPredictionError( pcCU, pcOrgYuv, iPartIdx, uiMEError, m_pcEncCfg->getUseHADME() );
         uiMECost = uiMEError + m_pcRdCost->getCost( uiMEBits );
 #if LG_RESTRICTEDRESPRED_M24766
-		if(pcCU->getResPredFlag(0) && iAddResiShift >= 0)
-		{
-			pcOrgYuv->add(iPUResiPredShift, pcCU->getPartitionSize(0), rpcResiPredYuv, pcCU->getWidth( 0 ), pcCU->getHeight( 0 ));
-		}
+        if(pcCU->getResPredFlag(0) && iAddResiShift >= 0)
+        {
+          pcOrgYuv->add(iPUResiPredShift, pcCU->getPartitionSize(0), rpcResiPredYuv, pcCU->getWidth( 0 ), pcCU->getHeight( 0 ));
+        }
 #endif
       }
@@ -3871,9 +3974,5 @@
   else
   {
-#if HHI_FIX
     rcMv = ( m_pcRdCost->useMultiviewReg() ? m_pcRdCost->getMultiviewOrgMvPred() : *pcMvPred );
-#else
-    rcMv = *pcMvPred;
-#endif
     xPatternSearchFast  ( pcCU, pcPatternKey, piRefY, iRefStride, &cMvSrchRngLT, &cMvSrchRngRB, rcMv, ruiCost );
   }
@@ -3977,5 +4076,4 @@
       uiSad += m_pcRdCost->getCost( x, y );
       
-#if HHI_FIX 
       // regularization cost
       if( m_pcRdCost->useMultiviewReg() )
@@ -3983,5 +4081,4 @@
         uiSad += m_pcRdCost->getMultiviewRegCost( x, y );
       }
-#endif
 
       if ( uiSad < uiSadBest )
@@ -4281,6 +4378,6 @@
     {
 #if LG_RESTRICTEDRESPRED_M24766
-		pcCU->getPUResiPredShift(iPUResiPredShift, 0);
-		rpcYuvRec->add(iPUResiPredShift, pcCU->getPartitionSize(0), rpcYuvResPrd, uiWidth, uiHeight );
+      pcCU->getPUResiPredShift(iPUResiPredShift, 0);
+      rpcYuvRec->add(iPUResiPredShift, pcCU->getPartitionSize(0), rpcYuvResPrd, uiWidth, uiHeight );
 #else
       rpcYuvRec->add( rpcYuvResPrd, uiWidth, uiHeight );
@@ -4294,5 +4391,5 @@
     {
       uiDistortion = m_pcRdCost->getDistVS( pcCU, 0, rpcYuvRec->getLumaAddr(), rpcYuvRec->getStride(),  pcYuvOrg->getLumaAddr(), pcYuvOrg->getStride(),  uiWidth,      uiHeight     , false, 0 );
-	}
+    }
     else    
     {
@@ -4349,7 +4446,12 @@
     pcCU->setTrIdxSubParts( 0, 0, pcCU->getDepth(0) );
     
+
 #if HHI_VSO // necessary? 
     // set Model
+#if SAIT_VSO_EST_A0033
+    if( !m_pcRdCost->getUseEstimatedVSD()&& m_pcRdCost->getUseRenModel() )
+#else
     if( m_pcRdCost->getUseRenModel() )
+#endif
     {
       Pel*  piSrc       = rpcYuvRec->getLumaAddr();
@@ -4395,6 +4497,6 @@
   {
 #if LG_RESTRICTEDRESPRED_M24766
-	  iPUResiPredShift[0] = iPUResiPredShift[1] = iPUResiPredShift[2] = iPUResiPredShift[3] = 0;
-	  rpcYuvResi->subtract(iPUResiPredShift, pcCU->getPartitionSize(0), pcYuvOrg, pcYuvPred, 0, uiWidth );
+    iPUResiPredShift[0] = iPUResiPredShift[1] = iPUResiPredShift[2] = iPUResiPredShift[3] = 0;
+    rpcYuvResi->subtract(iPUResiPredShift, pcCU->getPartitionSize(0), pcYuvOrg, pcYuvPred, 0, uiWidth );
 #else
   rpcYuvResi->subtract( pcYuvOrg, pcYuvPred, 0, uiWidth );
@@ -4405,6 +4507,6 @@
     {
 #if LG_RESTRICTEDRESPRED_M24766
-		pcCU->getPUResiPredShift(iPUResiPredShift, 0);
-		rpcYuvResi->subtract(iPUResiPredShift, pcCU->getPartitionSize(0), rpcYuvResi, rpcYuvResPrd, 0, uiWidth );
+      pcCU->getPUResiPredShift(iPUResiPredShift, 0);
+      rpcYuvResi->subtract(iPUResiPredShift, pcCU->getPartitionSize(0), rpcYuvResi, rpcYuvResPrd, 0, uiWidth );
 #else
       rpcYuvResi->subtract( rpcYuvResi, rpcYuvResPrd, 0, uiWidth );
@@ -4579,7 +4681,11 @@
     }
 
+
 #if HHI_VSO
-    // GT: reset Model, only fordQP necessary??
+#if SAIT_VSO_EST_A0033    
+    if( m_pcRdCost->getUseRenModel() && !m_pcRdCost->getUseEstimatedVSD() )
+#else
     if( m_pcRdCost->getUseRenModel() )
+#endif
     {
       Pel*  piSrc       = pcYuvOrg->getLumaAddr();
@@ -4624,7 +4730,7 @@
     pcYuvPred->copyToPartYuv( rpcYuvRec, 0 );
 #if LG_RESTRICTEDRESPRED_M24766
-	pcCU->getPUResiPredShift(iPUResiPredShift, 0);
-	rpcYuvRec->add(iPUResiPredShift, pcCU->getPartitionSize(0), rpcYuvResPrd,   uiWidth, uiHeight );
-	iPUResiPredShift[0] = iPUResiPredShift[1] = iPUResiPredShift[2] = iPUResiPredShift[3] = 0;
+    pcCU->getPUResiPredShift(iPUResiPredShift, 0);
+    rpcYuvRec->add(iPUResiPredShift, pcCU->getPartitionSize(0), rpcYuvResPrd,   uiWidth, uiHeight );
+    iPUResiPredShift[0] = iPUResiPredShift[1] = iPUResiPredShift[2] = iPUResiPredShift[3] = 0;
     rpcYuvRec->add(iPUResiPredShift, pcCU->getPartitionSize(0), rpcYuvResiBest, uiWidth, uiHeight );
 #else
@@ -4685,6 +4791,11 @@
 
   // set Model
+
 #if HHI_VSO // necessary??
+#if SAIT_VSO_EST_A0033    
+  if( m_pcRdCost->getUseRenModel() && !m_pcRdCost->getUseEstimatedVSD() )
+#else
   if( m_pcRdCost->getUseRenModel() )
+#endif
   {
     Pel*  piSrc       = rpcYuvRec->getLumaAddr();
@@ -4693,5 +4804,4 @@
 }
 #endif
-
 }
 
@@ -4869,5 +4979,16 @@
     if ( m_pcRdCost->getUseVSO() )
     {
-      uiDistY = m_pcRdCost->getDistVS  ( pcCU, uiAbsPartIdx, pcPred->getLumaAddr( uiAbsPartIdx ), pcPred->getStride(), pcOrg->getLumaAddr( uiAbsPartIdx), pcOrg->getStride(), 1<< uiLog2TrSize, 1<< uiLog2TrSize, false, 0 ); // initialized with zero residual distortion
+#if SAIT_VSO_EST_A0033
+      if( m_pcRdCost->getUseEstimatedVSD() )
+      {
+        TComPicYuv* pcVirRec = m_pcRdCost->getVideoRecPicYuv();
+        TComPicYuv* pcVirOrg = m_pcRdCost->getDepthPicYuv();
+        uiDistY = m_pcRdCost->getDistPart( m_pTempPel, 1<< uiLog2TrSize, pcResi->getLumaAddr( uiAbsPartIdx ), pcResi->getStride(), pcVirRec->getLumaAddr(pcCU->getAddr(),pcCU->getZorderIdxInCU()+uiAbsPartIdx), pcVirOrg->getLumaAddr(pcCU->getAddr(),pcCU->getZorderIdxInCU()+uiAbsPartIdx), pcVirRec->getStride(), 1<< uiLog2TrSize, 1<< uiLog2TrSize );
+      }
+      else
+#endif
+      {      
+        uiDistY = m_pcRdCost->getDistVS  ( pcCU, uiAbsPartIdx, pcPred->getLumaAddr( uiAbsPartIdx ), pcPred->getStride(), pcOrg->getLumaAddr( uiAbsPartIdx), pcOrg->getStride(), 1<< uiLog2TrSize, 1<< uiLog2TrSize, false, 0 ); // initialized with zero residual distortion
+      }
     }
     else
@@ -4880,5 +5001,4 @@
 #endif
     }
-
 
     if ( puiZeroDist )
@@ -4909,9 +5029,18 @@
       if ( m_pcRdCost->getUseVSO() )
       {
-        static int iCount = 1; 
-        iCount++; 
-        m_cYuvRecTemp.addClipPartLuma( &m_pcQTTempTComYuv[uiQTTempAccessLayer], pcPred, uiAbsPartIdx, 1<< uiLog2TrSize  );
-        uiNonzeroDistY = m_pcRdCost->getDistVS( pcCU, uiAbsPartIdx, m_cYuvRecTemp.getLumaAddr(uiAbsPartIdx), m_cYuvRecTemp.getStride(),
-                                                pcOrg->getLumaAddr( uiAbsPartIdx ), pcOrg->getStride(), 1<< uiLog2TrSize,   1<< uiLog2TrSize, false, 0 );
+#if SAIT_VSO_EST_A0033
+        if ( m_pcRdCost->getUseEstimatedVSD() )
+        {          
+          TComPicYuv* pcVirRec = m_pcRdCost->getVideoRecPicYuv();
+          TComPicYuv* pcVirOrg = m_pcRdCost->getDepthPicYuv();
+          uiNonzeroDistY = m_pcRdCost->getDistPart( m_pcQTTempTComYuv[uiQTTempAccessLayer].getLumaAddr( uiAbsPartIdx ), m_pcQTTempTComYuv[uiQTTempAccessLayer].getStride(), pcResi->getLumaAddr( uiAbsPartIdx ), pcResi->getStride(), pcVirRec->getLumaAddr( pcCU->getAddr(), pcCU->getZorderIdxInCU()+uiAbsPartIdx ), pcVirOrg->getLumaAddr( pcCU->getAddr(), pcCU->getZorderIdxInCU()+uiAbsPartIdx ), pcVirRec->getStride(), 1<< uiLog2TrSize,    1<< uiLog2TrSize );
+        }
+        else
+#endif
+        {        
+          m_cYuvRecTemp.addClipPartLuma( &m_pcQTTempTComYuv[uiQTTempAccessLayer], pcPred, uiAbsPartIdx, 1<< uiLog2TrSize  );
+          uiNonzeroDistY = m_pcRdCost->getDistVS( pcCU, uiAbsPartIdx, m_cYuvRecTemp.getLumaAddr(uiAbsPartIdx), m_cYuvRecTemp.getStride(),
+                                                  pcOrg->getLumaAddr( uiAbsPartIdx ), pcOrg->getStride(), 1<< uiLog2TrSize,   1<< uiLog2TrSize, false, 0 );
+        }
       }
       else
@@ -5307,6 +5436,11 @@
   }
 
+
 #if HHI_VSO
+#if SAIT_VSO_EST_A0033
+  if( m_pcRdCost->getUseRenModel() && !m_pcRdCost->getUseEstimatedVSD() )
+#else
   if ( m_pcRdCost->getUseRenModel() ) //Only done if not split ( see return above )
+#endif
   {
     UInt  uiWidth     = 1<< uiLog2TrSize;
@@ -5977,6 +6111,20 @@
 
         assignWedgeDCs2Pred( pcWedgelet, piPredic, uiStride, iTestDC1, iTestDC2 );
-
-        Dist uiActDist = m_pcRdCost->getDistVS( pcCU, 0, piPredic, uiStride,  piOrig, uiStride, uiWidth, uiHeight, false, 0 );
+        
+        Dist uiActDist = RDO_DIST_MAX;
+#if SAIT_VSO_EST_A0033
+        if ( m_pcRdCost->getUseEstimatedVSD() )
+        {          
+          TComPicYuv* pcVirRec = m_pcRdCost->getVideoRecPicYuv();
+          TComPicYuv* pcVirOrg = m_pcRdCost->getDepthPicYuv();
+          uiActDist = m_pcRdCost->getDistPart( piPredic, uiStride, piOrig, uiStride, pcVirRec->getLumaAddr(pcCU->getAddr(),pcCU->getZorderIdxInCU()), pcVirOrg->getLumaAddr(pcCU->getAddr(),pcCU->getZorderIdxInCU()), pcVirRec->getStride(), uiWidth, uiHeight );
+        }
+        else       
+#else
+        {        
+          uiActDist = m_pcRdCost->getDistVS( pcCU, 0, piPredic, uiStride,  piOrig, uiStride, uiWidth, uiHeight, false, 0 );
+        }
+#endif
+
         if( uiActDist < uiBestDist || uiBestDist == RDO_DIST_MAX )
         {
@@ -6078,5 +6226,16 @@
     if( m_pcRdCost->getUseVSO() )
     {
-      uiActDist = m_pcRdCost->getDistVS( pcCU, 0, piPred, uiPredStride, piRef, uiRefStride, uiWidth, uiHeight, false, 0 );
+#if SAIT_VSO_EST_A0033
+      if ( m_pcRdCost->getUseEstimatedVSD() )
+      {          
+        TComPicYuv* pcVirRec = m_pcRdCost->getVideoRecPicYuv();
+        TComPicYuv* pcVirOrg = m_pcRdCost->getDepthPicYuv();
+        uiActDist = m_pcRdCost->getDistPart( piPred, uiPredStride, piRef, uiRefStride, pcVirRec->getLumaAddr(pcCU->getAddr(),pcCU->getZorderIdxInCU()), pcVirOrg->getLumaAddr(pcCU->getAddr(),pcCU->getZorderIdxInCU()), pcVirRec->getStride(), uiWidth, uiHeight );
+      }
+      else
+#endif
+      {      
+        uiActDist = m_pcRdCost->getDistVS( pcCU, 0, piPred, uiPredStride, piRef, uiRefStride, uiWidth, uiHeight, false, 0 );
+      }
     }
     else
@@ -6133,5 +6292,16 @@
     if( m_pcRdCost->getUseVSO() )
     {
-      uiActDist = m_pcRdCost->getDistVS( pcCU, 0, piPred, uiPredStride, piRef, uiRefStride, uiWidth, uiHeight, false, 0 );
+#if SAIT_VSO_EST_A0033
+      if ( m_pcRdCost->getUseEstimatedVSD() )
+      {          
+        TComPicYuv* pcVirRec = m_pcRdCost->getVideoRecPicYuv();
+        TComPicYuv* pcVirOrg = m_pcRdCost->getDepthPicYuv();
+        uiActDist = m_pcRdCost->getDistPart( piPred, uiPredStride, piRef, uiRefStride, pcVirRec->getLumaAddr(pcCU->getAddr(),pcCU->getZorderIdxInCU()+uiAbsPtIdx), pcVirOrg->getLumaAddr(pcCU->getAddr(),pcCU->getZorderIdxInCU()+uiAbsPtIdx), pcVirRec->getStride(), uiWidth, uiHeight );
+      }
+      else
+#endif
+      {      
+        uiActDist = m_pcRdCost->getDistVS( pcCU, 0, piPred, uiPredStride, piRef, uiRefStride, uiWidth, uiHeight, false, 0 );
+      }
     }
     else
